Description

Hello,

I'm using a lot the puppet function to query foreman from puppet (

https://github.com/ohadlevy/puppet-foreman/blob/master/foreman/lib/puppet/parser/functions/foreman.rb)

in my manifest.

I noticed that when nodes where running puppet they might not be listed when querying Foreman in the REST API.

ie: If I have 2 nodes in hostgroup webservers and I query all hosts in that hostgroup

and I run puppet in the 2 nodes at the same time, foreman may list only one node instead of 2 in the answer.

I reproduced that with debug using http client when puppet was running on my nodes :

http://pastebin.com/C1rAeGMN

you can see that the 3 queries are only 1 second spaced

obvioulsy shinken51 was not deleted during the process

during the second request foreman replied only 2 facts instead of 3

I'm running foreman 1.1 with passenger + mysql

Puppet is puppet 3.0 (behavior was the same with puppet2.7)

Using puppetdb

This is quite painfull for us as a big part of our manifest is

writted to rely on Foreman and to reload dynamically the daemons.

Related issues:

Related to Foreman - Bug #2486: Fact values importer recreating all values in... Closed 05/10/2013

History

#1 - 04/12/2013 06:00 AM - Romain Vrignaud

- Target version set to 1.2.0

#2 - 05/10/2013 07:47 AM - Dominic Cleal

- Status changed from New to Feedback

I think this might be #2486, but I'm not certain - I found that problem in the process of investigating this one.  The issue there was all facts relating to a

host were deleted and then recreated when they were uploaded, rather than just updating the ones that changed.

Do you have a more complete log file?  I'm particularly interested if you get /fact_values/create requests at the same time as your queries.

#3 - 05/10/2013 07:48 AM - Dominic Cleal

(alternatively, if you can test the patch in #2486 that would be fantastic.. I think it'll apply against 1.1)

#4 - 05/30/2013 02:29 PM - Ohad Levy

ping?
https://github.com/ohadlevy/puppet-foreman/blob/master/foreman/lib/puppet/parser/functions/foreman.rb
http://pastebin.com/C1rAeGMN
https://projects.theforeman.org/issues/2486
https://projects.theforeman.org/issues/2486


#5 - 06/25/2013 07:15 AM - Joseph Magen

- Assignee set to Joseph Magen

#6 - 06/25/2013 07:23 AM - Ohad Levy

Joseph, I'm not sure if there is anything to do here besides asking Romain to retry, I believe we solved this issue.

#7 - 07/01/2013 10:57 AM - Romain Vrignaud

- Status changed from Feedback to Resolved

Can't reproduce since migration to 1.2-RC3.

Seems to be fixed by #2486.

Closing it
